# Josh User Interface

![Static Badge](https://img.shields.io/badge/Lit-Based-%20)

Fourth Time's The Charm! (tm)

JUI is a C++20 Library for building interactive menus in OpenGL / Redacted3D.

It is expressly built with our Redacted3D engine in mind, but steps have been taken to support OpenGL generally.

## Abstract

JUI provides a set of objects that we term Widgets. Widgets can be styled and laid out on-screen in relation to each other. Each widget has a single parent, and a list of child elements. Your root widget should be a Scene object.

Provided widgets include Scene, Rect, Text, TextRect, Button, TextButton, TextInputForms, Slider, Image, ImageRect, RadioButton

## Features

### Why use this instead of imgui?

## Usage

## Examples

![JUI First Showcase](showcase.png)


Browse the src/Demos directories for examples of building and interacting with things in JUI.

## Documentation

Documentation is automatically generated from latest commit and is hosted at https://doc.redacted.cc/jui .

## Contributing

Contributions to JUI are welcome! Feel free to file bug reports or feature requests by creating an Issue. Pull requests are also very welcome!

## History

JUI started out as my menu toolkit for the LOVE2D framework many years ago. Between then and now I had re-implemented it twice, once for MonoGame Framework, and again in C++ for SDL2. Legacy versions are listed below.

JUI v1 - LOVE2D / Lua

JUI v2 - MonoGame / C#

JUI v3 - SDL2 / C++


## License

JUI is expressly released without a license, under no restrictions. We dedicate all of our works to the public domain for the (hopeful) betterment of humanity.


## Acknowledgements

JUI is developed and maintained by Joshua O'Leary from Redacted Software Group, and all the wonderful contributors.