#include <JUI/Base/RectBase.hpp>
#include <JGL/JGL.h>

using namespace JGL;

namespace JUI {
    RectBase::RectBase() {}

    bool RectBase::GetClipsDescendants() const { return clips_descendants;}

    void RectBase::SetClipsDescendants(bool clipping) { clips_descendants = clipping;}

    void RectBase::BGColor(const Color4 &col) { bg_color = col;}

    void RectBase::BorderColor(const Color4 &col) { border_color = col;}

    void RectBase::SetBorderWidth(float w) {border_width = w;}

    float RectBase::GetBorderWidth() const { return border_width;}

    Color4 RectBase::GetBorderColor() const { return border_color;}

    Color4 RectBase::BGColor() const { return bg_color; }

    void RectBase::SetBorderStyling(const Color4 &color, float width) {
        BorderColor(color);
        SetBorderWidth(width);
    }

    void RectBase::Draw(const Vector2 &abs_pos, const Vector2 &abs_size) {
        // Background rect
        J2D::Begin();
        J2D::FillRect(bg_color, abs_pos, abs_size);

        // Outline rect

        Vector2 border_offset = {border_width/2, border_width/2};


        // TODO: implement border_mode behavior when rendering here.

        if (corner_rounding_radius >= 0)
            J2D::OutlineRect(border_color, abs_pos - border_offset, abs_size + (border_offset*2), border_width);
        J2D::End();
    }


}