#include "JUI/Widgets/TextRect.hpp"

namespace JUI {
    TextRect::TextRect() : Rect(), TextBase() {}
    TextRect::TextRect(Widget* parent) : TextRect() {
        this->SetParent(parent);
    }

    void TextRect::Update(float delta) {

        if (fit_text)
        {

            Vector2 abs_pos = this->GetAbsolutePosition();
            Vector2 abs_size = this->GetAbsoluteSize();

            // TODO: Apply this everywhere..
            Vector2 pad_shifts_pos_by = {
                    pad_left.Pixels + (pad_left.Scale * abs_size.x),
                    pad_top.Pixels + (pad_left.Scale * abs_size.y)
            };
            Vector2 pad_shrinks_size_by = {
                    pad_right.Pixels + (pad_left.Scale * abs_size.x),
                    pad_bottom.Pixels + (pad_right.Scale * abs_size.y)
            };

            Vector2 size = this->set_font.MeasureString(this->content, this->text_size);
            size += pad_shrinks_size_by*2.f;

            if (abs_size.x < size.x)
                this->size.X.Pixels = size.x;
            if (abs_size.y < size.y)
                this->size.Y.Pixels = size.y;

        }

        Rect::Update(delta);
        TextBase::Update(delta);
    }



    void TextRect::Draw() {
        Rect::Draw();


        Vector2 abs_pos = this->GetAbsolutePosition();
        Vector2 abs_size = this->GetAbsoluteSize();

        // TODO: Apply this everywhere..
        Vector2 pad_shifts_pos_by = {
                pad_left.Pixels + (pad_left.Scale * abs_size.x),
                pad_top.Pixels + (pad_left.Scale * abs_size.y)
        };
        Vector2 pad_shrinks_size_by = {
                pad_right.Pixels + (pad_left.Scale * abs_size.x),
                pad_bottom.Pixels + (pad_right.Scale * abs_size.y)
        };

        TextBase::Draw(abs_pos + pad_shifts_pos_by, abs_size - pad_shrinks_size_by*2);
    }


}


